package example.incrementallock;

import java.util.concurrent.locks.Lock;

public class ExampleThread extends Thread
{
	protected int threadIndex;
	protected Lock primaryLock;
	protected Lock secondaryLock;
	

	public ExampleThread(SharedResource sharedResource,
			boolean invertLockAcquisitionOrder,
			int threadIndex)
	{
		this.threadIndex = threadIndex;
		
		if (invertLockAcquisitionOrder)
		{
			this.primaryLock = sharedResource.getLockA();
			this.secondaryLock = sharedResource.getLockB();
		}
		else
		{
			this.primaryLock = sharedResource.getLockB();
			this.secondaryLock = sharedResource.getLockA();
		}
	}

	@Override
	public void run()
	{
		try
		{
			primaryLock.lock();
			System.out.println("Thread " + getName() + "' obtained read-lock");

			// do something
			Thread.sleep(1000*threadIndex);

			secondaryLock.lock();
			System.out.println("Thread " + getName() + "' obtained write-lock");
		}
		catch (InterruptedException exce)
		{
			return;
		}

		finally
		{
			secondaryLock.unlock();
			primaryLock.unlock();
		}

		System.out.println("Thread " + getName() + "' terminating");
	}
}
