package example.incrementallock;

public class ExampleThread2 extends ExampleThread
{	
	public ExampleThread2(SharedResource sharedResource, 
							boolean invertLockAcquisitionOrder,
							int threadIndex)
	{
		super(	sharedResource, 
				invertLockAcquisitionOrder,
				threadIndex);
	}
	
	@Override
	public void run() 
	{
		boolean success=false;
		try
		{
			primaryLock.lock();
			System.out.println("Thread " + getName() + "' obtained read-lock");			
			
			//simulate some work
			Thread.sleep(1000 * threadIndex);
			
			if (secondaryLock.tryLock())
			{
				System.out.println("Thread " + getName() + 
									"' obtained write-lock");
				success = true;
			}
			else System.out.println("Thread " +getName()+" failed to acquire write lock." + 
									" Relinquishing first lock");
		}
		catch (InterruptedException exce)
		{
			return;
		}
		finally
		{
			primaryLock.unlock();
			if (success) secondaryLock.unlock();
		}
		System.out.println("Thread " + getName() + "' terminating");
	}	
}
