package example.noarbitration;

public class Train extends Thread
{
	private Train other;
	
	protected boolean stopped;
	private String trainId;

	public Train(String trainId)
	{
		this.trainId = trainId;
		this.stopped = true;
	}

	public void setOther(Train other)
	{
		this.other = other;
	}

	protected synchronized void waitUntilMoved() throws InterruptedException
	{
		while (this.stopped)
			wait();
	}
	
	protected synchronized void moveTrain()
	{
		if (this.stopped)
		{
			this.stopped = false;
			System.out.println(trainId + " train now moving ..");
			notify();
		}
	}
	
	@Override
	public void run()
	{
		System.out.println( this + " train reached barrier...");

		try
		{
			other.waitUntilMoved();
			moveTrain();
		}
		catch (InterruptedException exce)
		{
			System.out.println("Thread halted ...");
		}
	}

	@Override
	public String toString()
	{
		return trainId;
	}

}