package example.workeraggregation;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class Worker extends Thread
{
	protected Lock lock;
	protected Worker coWorker;
	protected int workerIndex;
	
	public Worker(int workerIndex)
	{
		lock = new ReentrantLock();
		this.workerIndex = workerIndex;
	}
	
	public void setCoWorker(Worker coWorker){this.coWorker = coWorker;}
	
	public void lock(){lock.lock();}
	public void unlock(){lock.unlock();}
	
	@Override
	public void run()
	{		
		lock();
		System.out.println("Thread " + getName()+ " started ...");
				
		try
		{
			//simulate some work
			Thread.sleep(1000 *workerIndex);
			if (coWorker!=null)
			{
				coWorker.lock();
				System.out.println("Thread " + getName()+ " co-opted co-worker " + coWorker.getName());
			}
		}
		catch (InterruptedException exce)
		{
			return;
		}
		finally
		{
			coWorker.unlock();
			unlock();
		}
	}
	
}
